#include <libregexis024tools/stringmatching.h>
#include <assert.h>
#include <stdexcept>
#include <libregexis024sol/expr_compiler.h>

using namespace regexis024;
using namespace std;

void test(const string& input, const string& pattern, const MatchInfo& right_answer) {
    MatchInfo given_answer;
    track_var_list retTrackVarList;
    string retStatus;
    matchStrToRegexp(input, pattern, given_answer, retTrackVarList, retStatus);
    if (given_answer != right_answer) {
        throw runtime_error("Test failed");
    }
    printf("Test passed\n");
}

int main() {
    test("b", "#boba(b)", MatchInfo({{0, 0}, {1, 1}}, {}));
    test("abc", "!selarr{boba{ca}}^a#boba(b)c$", MatchInfo({{0, 1}, {1, 2}}, {1, 2}));
    for (int i = 0; i < 64; i++) {
        std::string T;
        T += ('a' + (i >> 3));
        T+= ('a' + (i % 8));
        test(T, "(((a|b)|(c|d))|((e|f)|(g|h)))!r{2}", MatchInfo({}, {}));
    }
    test("abba", "!select{M{max}}a#M(b*)a", MatchInfo({}, {1, 3}));
    test("abba", "!dfa;!select{M{max}}a#M(b*)a", MatchInfo({}, {1, 3}));
    test("abba", "!select{M{max}}a#M(!any;*)a", MatchInfo({}, {1, 3}));
    test("abba", "!dfa;!select{M{max}}a#M(!any;*)a", MatchInfo({}, {1, 3}));
    test("", "", MatchInfo({}, {}));
    test("a", "a", MatchInfo({}, {}));
    test("a3", "[abc]3", MatchInfo({}, {}));
    test("b3", "[abc]3", MatchInfo({}, {}));
    test("c3", "[abc]3", MatchInfo({}, {}));
    test("aa", "aa", MatchInfo({}, {}));
    test("aaaaa", "a*", MatchInfo({}, {}));
    test("bababbaa", "[ab]*", MatchInfo({}, {}));
    test("bababbaa", "!dfa;[ab]*", MatchInfo({}, {}));
    return 0;
}
